Index: TvEngine3/TVLibrary/SetupTv/Sections/RadioCombinations.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/RadioCombinations.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/RadioCombinations.cs	(working copy)
@@ -22,12 +22,11 @@
 using System.Collections.Generic;
 using System.Windows.Forms;
 using TvControl;
-using Gentle.Framework;
 using TvDatabase;
 using TvLibrary.Interfaces;
 using similaritymetrics;
 using MediaPortal.UserInterface.Controls;
-using TvLibrary.Log;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -56,7 +55,7 @@
     private readonly MPListViewStringColumnSorter lvwColumnSorter2;
     private readonly MPListViewStringColumnSorter lvwColumnSorter3;
 
-    private Dictionary<int, CardType> cards;
+    private IDictionary<int, CardType> cards;
 
     public RadioCombinations(string name)
       : base(name)
@@ -102,38 +101,35 @@
 
     private void mpComboBoxCard_SelectedIndexChanged(object sender, EventArgs e)
     {
+      Application.UseWaitCursor = true;
       mpListViewChannels.BeginUpdate();
       try
       {
         mpListViewChannels.Items.Clear();
         mpListViewMapped.Items.Clear();
 
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        CardInfo cardInfo = (CardInfo)mpComboBoxCard.SelectedItem;
+        Card card = ((CardInfo)mpComboBoxCard.SelectedItem).Card;
 
-        Card card = cardInfo.Card;
+        // get cardtype - dvb, analogue etc.
         CardType cardType = cards[card.IdCard];
-        IList<ChannelMap> maps = card.ReferringChannelMap();
 
+        TvBusinessLayer layer = new TvBusinessLayer();
+        bool enableDVBS2 = (layer.GetSetting("dvbs" + card.IdCard + "enabledvbs2", "false").Value == "true");
 
         List<ListViewItem> items = new List<ListViewItem>();
+
+        IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(-1, ChannelType.Radio);
+        IDictionary<int, IList<TuningDetail>> dDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Radio);
+        IList<ChannelMap> maps = card.ReferringChannelMap();
         foreach (ChannelMap map in maps)
         {
           Channel channel = null;
-          try
-          {
-            channel = map.ReferencedChannel();
-          }
-          catch (Exception) {}
-          if (channel == null)
+          if (!dChannels.TryGetValue(map.IdChannel, out channel))
             continue;
-          if (channel.IsRadio == false)
-            continue;
-          TvBusinessLayer layer = new TvBusinessLayer();
-          bool enableDVBS2 = (layer.GetSetting("dvbs" + card.IdCard + "enabledvbs2", "false").Value == "true");
-          List<TuningDetail> tuningDetails = GetTuningDetailsByCardType(channel, cardType, enableDVBS2);
-          int imageIndex = GetImageIndex(tuningDetails);
+
+          List<TuningDetail> tuningDetails = ChannelListHelper.GetTuningDetailsByCardType(channel, dDetails, cardType, enableDVBS2);
+          
+          int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
           ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
           item.Tag = channel;
           items.Add(item);
@@ -144,6 +140,7 @@
       finally
       {
         mpListViewChannels.EndUpdate();
+        Application.UseWaitCursor = false;
       }
     }
 
@@ -153,32 +150,35 @@
       try
       {
         mpListViewMapped.Items.Clear();
-        if (mpListViewChannels.SelectedIndices == null)
-          return;
         if (mpListViewChannels.SelectedIndices.Count != 1)
           return;
         Card card = ((CardInfo)mpComboBoxCard.SelectedItem).Card;
         ListViewItem selectedItem = mpListViewChannels.Items[mpListViewChannels.SelectedIndices[0]];
         Channel selectedChannel = (Channel)selectedItem.Tag;
-        IList<Channel> allChannels = Channel.ListAll();
+
+        IList<Channel> allChannels = ChannelListHelper.GetChannelsOfTypeForGroup(-1, ChannelType.Radio);
+        IDictionary<int, IList<TuningDetail>> dDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Radio);
+        IDictionary<int, IList<ChannelMap>> dMaps = ChannelListHelper.GetDictionaryOfChannelMaps(ChannelType.Radio);
+
         List<ListViewItem> items = new List<ListViewItem>();
-        NotifyForm dlg = new NotifyForm("Searching for Similar Channels...",
-                                        "This can take some time\n\nPlease be patient...");
+        NotifyForm dlg = new NotifyForm("Searching for similar channels...",
+                                        "This can take some time.\n\nPlease be patient...");
         dlg.Show(this);
         dlg.WaitForDisplay();
         foreach (Channel channel in allChannels)
         {
-          if (channel.IsRadio == false)
-            continue;
-
           bool isMapped = false;
-          IList<ChannelMap> list = channel.ReferringChannelMap();
-          foreach (ChannelMap map in list)
+          IList<ChannelMap> maps;
+          dMaps.TryGetValue(channel.IdChannel, out maps);
+          if (maps != null)
           {
-            if (map.IdCard == card.IdCard)
+            foreach (ChannelMap map in maps)
             {
-              isMapped = true;
-              break;
+              if (map.IdCard == card.IdCard)
+              {
+                isMapped = true;
+                break;
+              }
             }
           }
           if (isMapped)
@@ -187,8 +187,9 @@
           Levenstein comparer = new Levenstein();
           float result = comparer.getSimilarity(selectedChannel.DisplayName, channel.DisplayName);
 
-          IList<TuningDetail> details = channel.ReferringTuningDetail();
-          int imageIndex = GetImageIndex(details);
+          IList<TuningDetail> details;
+          dDetails.TryGetValue(channel.IdChannel, out details);
+          int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, details);
           ListViewItem item = new ListViewItem((result * 100f).ToString("f2") + "%", imageIndex);
           item.Tag = channel;
           item.SubItems.Add(channel.DisplayName);
@@ -332,90 +333,5 @@
       // Perform the sort with these new sort options.
       mpListViewMapped.Sort();
     }
-
-    private static List<TuningDetail> GetTuningDetailsByCardType(Channel channel, CardType cardType, bool enableDVBS2)
-    {
-      List<TuningDetail> result = new List<TuningDetail>();
-      foreach (TuningDetail tDetail in channel.ReferringTuningDetail())
-      {
-        switch (cardType)
-        {
-          case CardType.Analog:
-            if (tDetail.ChannelType == 0)
-              result.Add(tDetail);
-            break;
-          case CardType.Atsc:
-            if (tDetail.ChannelType == 1)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbC:
-            if (tDetail.ChannelType == 2)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbS:
-            if (tDetail.ChannelType == 3)
-            {
-              if (!enableDVBS2 && (tDetail.Pilot > -1 || tDetail.RollOff > -1))
-              {
-                Log.Debug(String.Format(
-                  "Imported channel {0} detected as DVB-S2. Skipped! \n Enable \"DVB-S2 tuning\" option in your TV-Card properties to be able to combine these channels.",
-                  tDetail.Name));
-              }
-              else
-              {
-                result.Add(tDetail);
-              }
-            }
-            break;
-          case CardType.DvbT:
-            if (tDetail.ChannelType == 4)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbIP:
-            if (tDetail.ChannelType == 7)
-              result.Add(tDetail);
-            break;
-          case CardType.RadioWebStream:
-            if (tDetail.ChannelType == 5)
-              result.Add(tDetail);
-            break;
-          default:
-            break;
-        }
-      }
-      return result;
-    }
-
-    private static int GetImageIndex(IList<TuningDetail> tuningDetails)
-    {
-      bool hasFta = false;
-      bool hasScrambled = false;
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
-
-      int imageIndex;
-      if (hasFta && hasScrambled)
-      {
-        imageIndex = 2;
-      }
-      else if (hasScrambled)
-      {
-        imageIndex = 1;
-      }
-      else
-      {
-        imageIndex = 0;
-      }
-      return imageIndex;
-    }
   }
 }
\ No newline at end of file
Index: TvEngine3/TVLibrary/SetupTv/Sections/RadioEpgGrabber.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/RadioEpgGrabber.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/RadioEpgGrabber.cs	(working copy)
@@ -21,12 +21,11 @@
 using System;
 using System.Collections.Generic;
 using System.Windows.Forms;
-using TvControl;
-using Gentle.Framework;
 using TvDatabase;
 using TvLibrary.Log;
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -108,139 +107,48 @@
     public override void OnSectionActivated()
     {
       mpListView1.BeginUpdate();
+      base.OnSectionActivated();
+      mpListView1.Items.Clear();
+      List<ListViewItem> items = new List<ListViewItem>();
       try
       {
         LoadLanguages();
         TvBusinessLayer layer = new TvBusinessLayer();
         Setting setting = layer.GetSetting("epgRadioStoreOnlySelected");
         mpCheckBoxStoreOnlySelected.Checked = (setting.Value == "yes");
-        Dictionary<string, CardType> cards = new Dictionary<string, CardType>();
-        IList<Card> dbsCards = Card.ListAll();
-        foreach (Card card in dbsCards)
-        {
-          cards[card.DevicePath] = RemoteControl.Instance.Type(card.IdCard);
-        }
-        base.OnSectionActivated();
-        mpListView1.Items.Clear();
 
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof(Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        SqlStatement stmt = sb.GetStatement(true);
-        IList<Channel> channels = ObjectFactory.GetCollection<Channel>(stmt.Execute());
+        IDictionary<int, IList<ChannelMap>> dChannelMaps = ChannelListHelper.GetDictionaryOfChannelMaps(ChannelType.Radio);
+        IDictionary<int, IList<TuningDetail>> dTuningDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Radio);
+        IDictionary<int, CardType> dCardTypes = ChannelListHelper.GetDictionaryOfInstalledCardTypes();
 
+        IList<TuningDetail> tuningDetails;
+        IList<ChannelMap> maps;
+        IList<Channel> channels = ChannelListHelper.GetChannelsOfTypeForGroup(-1, ChannelType.Radio);
         foreach (Channel ch in channels)
         {
-          bool analog = false;
-          bool dvbc = false;
-          bool dvbt = false;
-          bool dvbs = false;
-          bool atsc = false;
-          bool dvbip = false;
-          bool hasFta = false;
-          bool hasScrambled = false;
-          if (ch.IsRadio == false)
+          dTuningDetails.TryGetValue(ch.IdChannel, out tuningDetails);
+
+          if (ChannelListHelper.HasWebstreamTuningDetails(tuningDetails))
             continue;
-          if (ch.IsWebstream())
-            continue;
+          int imageIndex = ChannelListIcons.GetChannelListIconIndex(ch, tuningDetails);
+          ListViewItem item = new ListViewItem(ch.DisplayName, imageIndex);
+          items.Add(item);
 
-          IList<TuningDetail> tuningDetails = ch.ReferringTuningDetail();
-          foreach (TuningDetail detail in tuningDetails)
-          {
-            if (detail.FreeToAir)
-            {
-              hasFta = true;
-            }
-            if (!detail.FreeToAir)
-            {
-              hasScrambled = true;
-            }
-          }
+          dChannelMaps.TryGetValue(ch.IdChannel, out maps);
+          string MappingNames = ChannelListHelper.GetMappingNames(maps, dCardTypes, tuningDetails);
 
-          int imageIndex;
-          if (hasFta && hasScrambled)
-          {
-            imageIndex = 2;
-          }
-          else if (hasScrambled)
-          {
-            imageIndex = 1;
-          }
-          else
-          {
-            imageIndex = 0;
-          }
-
-          ListViewItem item = mpListView1.Items.Add(ch.DisplayName, imageIndex);
-          foreach (ChannelMap map in ch.ReferringChannelMap())
-          {
-            if (cards.ContainsKey(map.ReferencedCard().DevicePath))
-            {
-              CardType type = cards[map.ReferencedCard().DevicePath];
-              switch (type)
-              {
-                case CardType.Analog:
-                  analog = true;
-                  break;
-                case CardType.DvbC:
-                  dvbc = true;
-                  break;
-                case CardType.DvbT:
-                  dvbt = true;
-                  break;
-                case CardType.DvbS:
-                  dvbs = true;
-                  break;
-                case CardType.Atsc:
-                  atsc = true;
-                  break;
-                case CardType.DvbIP:
-                  dvbip = true;
-                  break;
-              }
-            }
-          }
-          string line = "";
-          if (analog)
-          {
-            line += "Analog";
-          }
-          if (dvbc)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-C";
-          }
-          if (dvbt)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-T";
-          }
-          if (dvbs)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-S";
-          }
-          if (atsc)
-          {
-            if (line != "")
-              line += ",";
-            line += "ATSC";
-          }
-          if (dvbip)
-          {
-            if (line != "")
-              line += ",";
-            line += "DVB-IP";
-          }
-          item.SubItems.Add(line);
+          item.SubItems.Add(MappingNames);
           item.Checked = ch.GrabEpg;
           item.Tag = ch;
         }
       }
+      catch (Exception exp)
+      {
+        Log.Error("SetupTV.RadioEpgGrabber.OnSectionActivated error: {0}", exp.StackTrace);
+      }
       finally
       {
+        mpListView1.Items.AddRange(items.ToArray());
         mpListView1.EndUpdate();
       }
     }
@@ -401,7 +309,7 @@
         TvBusinessLayer layer = new TvBusinessLayer();
         Setting setting = layer.GetSetting("radioLanguages");
         setting.Value = ",";
-        Log.WriteFile("tvsetup:epggrabber:none: epglang={0}", setting.Value);
+        Log.WriteFile("tvsetup:epgradiograbber:none: epglang={0}", setting.Value);
         setting.Persist();
       }
       finally
Index: TvEngine3/TVLibrary/SetupTv/Sections/TestChannels.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/TestChannels.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/TestChannels.cs	(working copy)
@@ -120,7 +120,7 @@
     ///   Splits a <see cref = "List{T}" /> into multiple chunks.
     /// </summary>
     /// <typeparam name = "T"></typeparam>
-    /// <param name = "list">The list to be chunked.</param>
+    /// <param name = "source">The list to be chunked.</param>
     /// <param name = "chunkSize">The size of each chunk.</param>
     /// <returns>A list of chunks.</returns>
     public static List<List<T>> SplitIntoChunks<T>(List<T> source, int chunkSize)
Index: TvEngine3/TVLibrary/SetupTv/Sections/TestService.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/TestService.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/TestService.cs	(working copy)
@@ -24,10 +24,10 @@
 using System.Windows.Forms;
 using TvControl;
 using TvDatabase;
-using TvLibrary.Interfaces;
 using TvLibrary.Log;
 using Gentle.Framework;
 using SetupControls;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -53,7 +53,6 @@
       DoubleBuffered = true;
     }
 
-
     public override void OnSectionActivated()
     {
       _cards = Card.ListAll();
@@ -539,7 +538,6 @@
       MessageBox.Show("EPG grabber will restart in a few seconds..");
     }
 
-
     /// <summary>
     /// returns the virtualcard which is timeshifting the channel specified
     /// </summary>
@@ -604,92 +602,56 @@
 
     private void comboBoxGroups_SelectedIndexChanged(object sender, EventArgs e)
     {
+      Cursor.Current = Cursors.WaitCursor;
+
       ComboBoxExItem idItem = (ComboBoxExItem)comboBoxGroups.Items[comboBoxGroups.SelectedIndex];
+
+      mpComboBoxChannels.BeginUpdate();
       mpComboBoxChannels.Items.Clear();
+
+      IDictionary<int, IList<TuningDetail>> dTuningDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(idItem.Id, ChannelType.Tv);
+      IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(idItem.Id, ChannelType.Tv);
+      List<ComboBoxExItem> items = new List<ComboBoxExItem>();
+      IList<TuningDetail> tuningDetails;
+      int imageIndex = 0;
+
       if (idItem.Id == -1)
       {
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        SqlStatement stmt = sb.GetStatement(true);
-        IList<Channel> channels = ObjectFactory.GetCollection<Channel>(stmt.Execute());
-        foreach (Channel ch in channels)
+        IList<Channel> channels = Channel.ListAll();
+        foreach (Channel channel in channels)
         {
-          if (ch.IsTv == false) continue;
-          bool hasFta = false;
-          bool hasScrambled = false;
-          IList<TuningDetail> tuningDetails = ch.ReferringTuningDetail();
-          foreach (TuningDetail detail in tuningDetails)
-          {
-            if (detail.FreeToAir)
-            {
-              hasFta = true;
-            }
-            if (!detail.FreeToAir)
-            {
-              hasScrambled = true;
-            }
-          }
+          if (!channel.IsTv) 
+            continue;
 
-          int imageIndex;
-          if (hasFta && hasScrambled)
-          {
-            imageIndex = 5;
-          }
-          else if (hasScrambled)
-          {
-            imageIndex = 4;
-          }
-          else
-          {
-            imageIndex = 3;
-          }
-          ComboBoxExItem item = new ComboBoxExItem(ch.DisplayName, imageIndex, ch.IdChannel);
-
-          mpComboBoxChannels.Items.Add(item);
+          dTuningDetails.TryGetValue(channel.IdChannel, out tuningDetails);
+          imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
+          ComboBoxExItem item = new ComboBoxExItem(channel.DisplayName, imageIndex, channel.IdChannel);
+          items.Add(item);
         }
       }
       else
       {
         ChannelGroup group = ChannelGroup.Retrieve(idItem.Id);
         IList<GroupMap> maps = group.ReferringGroupMap();
+        Channel channel;
+
         foreach (GroupMap map in maps)
         {
-          Channel ch = map.ReferencedChannel();
-          if (ch.IsTv == false) continue;
-          bool hasFta = false;
-          bool hasScrambled = false;
-          IList<TuningDetail> tuningDetails = ch.ReferringTuningDetail();
-          foreach (TuningDetail detail in tuningDetails)
+          if (dChannels.TryGetValue(map.IdChannel, out channel))
           {
-            if (detail.FreeToAir)
-            {
-              hasFta = true;
-            }
-            if (!detail.FreeToAir)
-            {
-              hasScrambled = true;
-            }
+            dTuningDetails.TryGetValue(channel.IdChannel, out tuningDetails);
+            imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
+            ComboBoxExItem item = new ComboBoxExItem(channel.DisplayName, imageIndex, channel.IdChannel);
+            items.Add(item);
           }
-
-          int imageIndex;
-          if (hasFta && hasScrambled)
-          {
-            imageIndex = 5;
-          }
-          else if (hasScrambled)
-          {
-            imageIndex = 4;
-          }
-          else
-          {
-            imageIndex = 3;
-          }
-          ComboBoxExItem item = new ComboBoxExItem(ch.DisplayName, imageIndex, ch.IdChannel);
-          mpComboBoxChannels.Items.Add(item);
         }
       }
+
+      mpComboBoxChannels.Items.AddRange(items.ToArray());
+      mpComboBoxChannels.EndUpdate();
       if (mpComboBoxChannels.Items.Count > 0)
         mpComboBoxChannels.SelectedIndex = 0;
+      Cursor.Current = Cursors.Default;
     }
   }
 }
\ No newline at end of file
Index: TvEngine3/TVLibrary/SetupTv/Sections/TvChannelMapping.cs
===================================================================
--- TvEngine3/TVLibrary/SetupTv/Sections/TvChannelMapping.cs	(revision 28196)
+++ TvEngine3/TVLibrary/SetupTv/Sections/TvChannelMapping.cs	(working copy)
@@ -22,11 +22,10 @@
 using System.Collections.Generic;
 using System.Windows.Forms;
 using TvControl;
-using Gentle.Framework;
 using TvDatabase;
 using TvLibrary.Interfaces;
 using MediaPortal.UserInterface.Controls;
-using TvLibrary.Log;
+using SetupTv.Sections.Helpers;
 
 namespace SetupTv.Sections
 {
@@ -52,17 +51,16 @@
       }
     }
 
-    public TvChannelMapping()
-      : this("TV Mapping") {}
-
     private readonly MPListViewStringColumnSorter lvwColumnSorter1;
     private readonly MPListViewStringColumnSorter lvwColumnSorter2;
 
+    public TvChannelMapping()
+      : this("TV Mapping") {}
+
     public TvChannelMapping(string name)
       : base(name)
     {
       InitializeComponent();
-      //mpListViewChannels.ListViewItemSorter = new MPListViewSortOnColumn(1);
       lvwColumnSorter1 = new MPListViewStringColumnSorter();
       lvwColumnSorter1.Order = SortOrder.Ascending;
       mpListViewChannels.ListViewItemSorter = lvwColumnSorter1;
@@ -107,7 +105,7 @@
           mpListViewChannels.Items.Remove(item);
           string displayName = channel.DisplayName;
           if (mpCheckBoxMapForEpgOnly.Checked)
-            displayName = channel.DisplayName + " (EPG Only)";
+            displayName += " (EPG Only)";
           ListViewItem newItem = mpListViewMapped.Items.Add(displayName, item.ImageIndex);
           newItem.Tag = map;
         }
@@ -119,7 +117,6 @@
         mpListViewChannels.EndUpdate();
         mpListViewMapped.EndUpdate();
       }
-      //DatabaseManager.Instance.SaveChanges();
     }
 
     private void mpButtonUnmap_Click(object sender, EventArgs e)
@@ -153,58 +150,46 @@
         mpListViewChannels.EndUpdate();
         mpListViewMapped.EndUpdate();
       }
-      // DatabaseManager.Instance.SaveChanges();
     }
 
     private void mpComboBoxCard_SelectedIndexChanged(object sender, EventArgs e)
     {
-      //DatabaseManager.Instance.SaveChanges();
-
+      Application.UseWaitCursor = true;
       mpListViewChannels.BeginUpdate();
       mpListViewMapped.BeginUpdate();
       try
       {
-        mpListViewMapped.Items.Clear();
         mpListViewChannels.Items.Clear();
+        mpListViewMapped.Items.Clear();
 
-        SqlBuilder sb = new SqlBuilder(StatementType.Select, typeof (Channel));
-        sb.AddOrderByField(true, "sortOrder");
-        SqlStatement stmt = sb.GetStatement(true);
-        IList<Channel> channels = ObjectFactory.GetCollection<Channel>(stmt.Execute());
-
         Card card = ((CardInfo)mpComboBoxCard.SelectedItem).Card;
-        IList<ChannelMap> maps = card.ReferringChannelMap();
 
-        // get cardtype, dvb, analogue etc.		
+        IList<Channel> channels = ChannelListHelper.GetChannelsOfTypeForGroup(-1, ChannelType.Tv);
+
+        // get cardtype - dvb, analogue etc.
         CardType cardType = RemoteControl.Instance.Type(card.IdCard);
-        //Card card = Card.Retrieve(card.IdCard);
+
         TvBusinessLayer layer = new TvBusinessLayer();
         bool enableDVBS2 = (layer.GetSetting("dvbs" + card.IdCard + "enabledvbs2", "false").Value == "true");
 
-
         List<ListViewItem> items = new List<ListViewItem>();
+
+        IDictionary<int, Channel> dChannels = ChannelListHelper.GetDictionaryOfChannelsForGroup(-1, ChannelType.Tv);
+        IDictionary<int, IList<TuningDetail>> dDetails = ChannelListHelper.GetDictionaryOfTuningDetailsForGroup(-1, ChannelType.Tv);
+        IList<ChannelMap> maps = card.ReferringChannelMap();
         foreach (ChannelMap map in maps)
         {
           Channel channel = null;
-          try
-          {
-            channel = map.ReferencedChannel();
-          }
-          catch (Exception) {}
-          if (channel == null)
+          if (!dChannels.TryGetValue(map.IdChannel, out channel))
             continue;
-          if (channel.IsTv == false)
-            continue;
 
-
-          List<TuningDetail> tuningDetails = GetTuningDetailsByCardType(channel, cardType, enableDVBS2);
-          bool foundValidTuningDetail = tuningDetails.Count > 0;
-          if (foundValidTuningDetail)
+          List<TuningDetail> tuningDetails = ChannelListHelper.GetTuningDetailsByCardType(channel, dDetails, cardType, enableDVBS2);
+          if (tuningDetails.Count > 0)
           {
-            int imageIndex = GetImageIndex(tuningDetails);
             string displayName = channel.DisplayName;
             if (map.EpgOnly)
-              displayName = channel.DisplayName + " (EPG Only)";
+              displayName += " (EPG Only)";
+            int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails);
             ListViewItem item = new ListViewItem(displayName, imageIndex);
             item.Tag = map;
             items.Add(item);
@@ -220,22 +205,18 @@
             }
           }
           else
-          {
             map.Delete();
-          }
         }
         mpListViewMapped.Items.AddRange(items.ToArray());
+
         items = new List<ListViewItem>();
         foreach (Channel channel in channels)
         {
-          if (channel.IsTv == false)
-            continue;
-          List<TuningDetail> tuningDetails = GetTuningDetailsByCardType(channel, cardType, enableDVBS2);
+          List<TuningDetail> tuningDetails = ChannelListHelper.GetTuningDetailsByCardType(channel, dDetails, cardType, enableDVBS2);
           // only add channel that is tuneable on the device selected.
-          bool foundValidTuningDetail = tuningDetails.Count > 0;
-          if (foundValidTuningDetail)
+          if (tuningDetails.Count > 0)
           {
-            int imageIndex = GetImageIndex(tuningDetails);
+            int imageIndex = ChannelListIcons.GetChannelListIconIndex(channel, tuningDetails); 
             ListViewItem item = new ListViewItem(channel.DisplayName, imageIndex);
             item.Tag = channel;
             items.Add(item);
@@ -248,6 +229,7 @@
       {
         mpListViewChannels.EndUpdate();
         mpListViewMapped.EndUpdate();
+        Application.UseWaitCursor = false;
       }
     }
 
@@ -310,90 +292,5 @@
       }
       map.Persist();
     }
-
-    private static List<TuningDetail> GetTuningDetailsByCardType(Channel channel, CardType cardType, bool enableDVBS2)
-    {
-      List<TuningDetail> result = new List<TuningDetail>();
-      foreach (TuningDetail tDetail in channel.ReferringTuningDetail())
-      {
-        switch (cardType)
-        {
-          case CardType.Analog:
-            if (tDetail.ChannelType == 0)
-              result.Add(tDetail);
-            break;
-          case CardType.Atsc:
-            if (tDetail.ChannelType == 1)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbC:
-            if (tDetail.ChannelType == 2)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbS:
-            if (tDetail.ChannelType == 3)
-            {
-              if (!enableDVBS2 && (tDetail.Pilot > -1 || tDetail.RollOff > -1))
-              {
-                Log.Debug(String.Format(
-                  "Imported channel {0} detected as DVB-S2. Skipped! \n Enable \"DVB-S2 tuning\" option in your TV-Card properties to be able to map these channels.",
-                  tDetail.Name));
-              }
-              else
-              {
-                result.Add(tDetail);
-              }
-            }
-            break;
-          case CardType.DvbT:
-            if (tDetail.ChannelType == 4)
-              result.Add(tDetail);
-            break;
-          case CardType.DvbIP:
-            if (tDetail.ChannelType == 7)
-              result.Add(tDetail);
-            break;
-          case CardType.RadioWebStream:
-            if (tDetail.ChannelType == 5)
-              result.Add(tDetail);
-            break;
-          default:
-            break;
-        }
-      }
-      return result;
-    }
-
-    private static int GetImageIndex(IList<TuningDetail> tuningDetails)
-    {
-      bool hasFta = false;
-      bool hasScrambled = false;
-      foreach (TuningDetail detail in tuningDetails)
-      {
-        if (detail.FreeToAir)
-        {
-          hasFta = true;
-        }
-        if (!detail.FreeToAir)
-        {
-          hasScrambled = true;
-        }
-      }
-
-      int imageIndex;
-      if (hasFta && hasScrambled)
-      {
-        imageIndex = 5;
-      }
-      else if (hasScrambled)
-      {
-        imageIndex = 4;
-      }
-      else
-      {
-        imageIndex = 3;
-      }
-      return imageIndex;
-    }
   }
 }
\ No newline at end of file
